package com.fp.persistence.pgeneral.test;

import java.sql.Timestamp;
import javax.persistence.Id;
import java.io.Serializable;
import javax.persistence.Table;
import java.math.BigDecimal;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.Column;
import java.lang.reflect.Field;
import javax.persistence.Transient;
import java.sql.Date;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TTESTVALORES*/
@Entity(name="TtestValores")
@Table(name="TTESTVALORES")
public class TtestValores extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TtestValores
*/
@Id
@Column(name="ID" ,nullable=false, updatable=false)
private Long pk;
@Column(name="DESCRIPCION", nullable=false)

/**
* null
*/
private String descripcion;

@Column(name="MONTO", nullable=false)

/**
* null
*/
private BigDecimal monto;

@Column(name="FECHA", nullable=false)

/**
* null
*/
private Date fecha;

@Column(name="FECHAHORA", nullable=false)

/**
* null
*/
private Timestamp fechahora;

@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* null
*/
private Integer recordversion;

/**Contructor por defecto*/
public TtestValores(){
}
/**Contructor de TtestValores
@param pPk Clave Primaria del entity
@param pDescripcion null
@param pMonto null
@param pFecha null
@param pFechahora null
*/
public TtestValores(Long pPk,String pDescripcion,BigDecimal pMonto,Date pFecha,Timestamp pFechahora){
 this();
 pk=pPk;
 descripcion=pDescripcion;
 monto=pMonto;
 fecha=pFecha;
 fechahora=pFechahora;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TtestValores
*/
public static TtestValores find(EntityManager pEntityManager,Object pKey) throws Exception{
    TtestValores obj = pEntityManager.find(TtestValores.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TtestValores
@return El objeto que referencia a la Clave primaria de TtestValores
*/
public Long getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TtestValores
@param pPk El objeto que referencia a la nueva Clave primaria de TtestValores
*/
public void setPk(Long pPk){
  pk=pPk;
}
/**Obtiene el valor de descripcion
@return valor de descripcion*/
public String getDescripcion(){
  return descripcion;
}
/**Fija el valor de descripcion
@param pDescripcion nuevo Valor de descripcion*/
public void setDescripcion(String pDescripcion){
  descripcion=pDescripcion;
}

/**Obtiene el valor de monto
@return valor de monto*/
public BigDecimal getMonto(){
  return monto;
}
/**Fija el valor de monto
@param pMonto nuevo Valor de monto*/
public void setMonto(BigDecimal pMonto){
  monto=pMonto;
}

/**Obtiene el valor de fecha
@return valor de fecha*/
public Date getFecha(){
  return fecha;
}
/**Fija el valor de fecha
@param pFecha nuevo Valor de fecha*/
public void setFecha(Date pFecha){
  fecha=pFecha;
}

/**Obtiene el valor de fechahora
@return valor de fechahora*/
public Timestamp getFechahora(){
  return fechahora;
}
/**Fija el valor de fechahora
@param pFechahora nuevo Valor de fechahora*/
public void setFechahora(Timestamp pFechahora){
  fechahora=pFechahora;
}

/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TtestValores))return false;
    TtestValores that = (TtestValores) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TtestValores
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TtestValores
*/
public Object createInstance(){
 TtestValores instance=new TtestValores();	
 return instance;
}
/**Clona la entidad TtestValores
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TtestValores p=(TtestValores)this.clone();
  return p;
}
}
